
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深入Jetty源码之SecurityHandler / iVAN</title>

    <meta name="description" content="深入Jetty源码之SecurityHandler 概述 Jetty的强大之处在于可以自由的配置某些组建的存在与否,以提升性能,减少复杂度,而其本身也因为这种特性而具有很强的可扩展性.SecurityHandler就是Jetty对Servlet中Security框架部分的实现,并可以根据实际需要装卸和替换.Servlet的安全框架主要有两个部分:数据传输的安全以及数据授权,对数据传输的安全,可以使用SSL对应的Connector实现,而对于数据授权安全,Servlet定义了一套自己的框架. Servlet的安全框架支持两种方式的验证:首先,是用于">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">深入Jetty源码之SecurityHandler</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>概述</h2>
<p>Jetty的强大之处在于可以自由的配置某些组建的存在与否，以提升性能，减少复杂度，而其本身也因为这种特性而具有很强的可扩展性。SecurityHandler就是Jetty对Servlet中Security框架部分的实现，并可以根据实际需要装卸和替换。Servlet的安全框架主要有两个部分：数据传输的安全以及数据授权，对数据传输的安全，可以使用SSL对应的Connector实现，而对于数据授权安全，Servlet定义了一套自己的框架。</p>
<p>Servlet的安全框架支持两种方式的验证：首先，是用于登陆的验证，对于定义了role-name的资源都需要进行登陆验证，Servlet支持NONE、BASIC、CLIENT-CERT、DIGEST、FORM等5种验证方式(&lt;login-config&gt;/&lt;auth-method&gt;)；除了用户登陆验证，Servlet框架还定义了role的概念，一个role可以包含一个或多个用户，一个用户可以隶属于多个role，一个资源可以有一个或多个role，只有这些定义的role才能访问该资源，用户只能访问它所隶属的role能访问的资源。另外，对一个Servlet来说，还可以定义role-name到role-link的映射关系，从文档上，这里的role-name是Servlet中使用的名字，而role-link是Container中使用的名字，感觉很模糊，从Jetty的角度，role-name是web.xml中在&lt;security-constraint&gt;/&lt;auth-constraint&gt;/&lt;role-name&gt;中对一个URL Pattern的role定义，而role-link则是UserIdentity中roles数组的值，而UserIdentity是LoginService中创建的，它从文件、数据库等加载已定义的user的信息：用户名、密码、它隶属的role等，如果Servlet中没有定义role-name到role-link的映射，则直接使用role-name去UserIdentity中比较role信息。</p>
<p>关于Servlet对Security框架的具体解释，可以参考Oracle的文档：<a href="http://docs.oracle.com/cd/E19798-01/821-1841/6nmq2cpk7/index.html" rel="external nofollow noreferrer">http://docs.oracle.com/cd/E19798-01/821-1841/6nmq2cpk7/index.html</a></p>
<p>在web.xml中，对用于登陆验证方式的定义如下：</p>
<p>   &lt;login-config&gt; <br />
     &lt;auth-method&gt;FORM&lt;/auth-method&gt; <br />
     &lt;realm-name&gt;Example-Based Authentiation Area&lt;/realm-name&gt; <br />
     &lt;form-login-config&gt; <br />
        &lt;form-login-page&gt;/jsp/security/protected/login.jsp&lt;/form-login-page&gt; <br />
        &lt;form-error-page&gt;/jsp/security/protected/error.jsp&lt;/form-error-page&gt; <br />
     &lt;/form-login-config&gt; <br />
   &lt;/login-config&gt; <br />
OR<br />
  &lt;login-config&gt;<br />
    &lt;auth-method&gt;BASIC&lt;/auth-method&gt;<br />
    &lt;realm-name&gt;Tomcat Manager Application&lt;/realm-name&gt;<br />
  &lt;/login-config&gt;<br />
<br />
而对资源所属role的定义如下：</p>
<p>  &lt;security-constraint&gt;<br />
  &lt;security-constraint&gt;<br />
    &lt;web-resource-collection&gt;<br />
      &lt;web-resource-name&gt;Status interface&lt;/web-resource-name&gt;<br />
      &lt;url-pattern&gt;/status/*&lt;/url-pattern&gt;<br />
    &lt;/web-resource-collection&gt;<br />    ...<br />
    &lt;auth-constraint&gt;<br />
       &lt;role-name&gt;manager-gui&lt;/role-name&gt;<br />
       &lt;role-name&gt;manager-script&lt;/role-name&gt;<br />
       &lt;role-name&gt;manager-jmx&lt;/role-name&gt;<br />
       &lt;role-name&gt;manager-status&lt;/role-name&gt;<br />
    &lt;/auth-constraint&gt;<br />
  &lt;/security-constraint&gt;</p>
<h2>Jetty对Servlet Security实现概述和类图</h2>
<p>在Jetty中，使用Authenticator接口抽象不同用户登陆验证的逻辑；使用LoginService接口抽象对用户名、密码的验证；使用UserIdentity保存内部定义的一个用户的用户名、密码、role集合；使用ConstraintMapping保存URL Pattern到role集合的映射；使用UserIdentity.Scope保存一个Servlet中role-name到role-link的映射。他们的类图如下：<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJsb2dqYXZhLm5ldC9pbWFnZXMvYmxvZ2phdmFfbmV0L2RsZXZpbi9KZXR0eV9TZWN1cml0eTIuanBn.jpg"><br />
<h2>UserIdentity实现</h2>
<p>UserIdentity表示一个用户的认证信息，它包含Subject和UserPrincipal，其中Subject是Java Security框架定义的类型，而UserPrincipal则用于存储用户名以及认证信息，在Jetty中一般使用KnownUser来存储，它包含了UserName以及Credential实例，其中Credential可以是Crypt、MD5、Password等。在Credential中定义了check方法用于验证传入的credential是否是正确的。<br />
<h2>IdentityService实现</h2>
<p>IdentityService我猜原本用于将UserIdentity、RunAsToken和当前Thread关联在一起，以及创建UserIdentity、RunAsToken，然而我看的版本中，DefaultIdentityService貌似还没有实现完成，目前只是根据提供的Subject、Principal、roles创建DefaultUserIdentity实例，以及使用runAsName创建RoleRunAsToken，对Servlet中的runAsToken，我看的Jetty版本也还没有实现完成。</p>
<p>    public UserIdentity newUserIdentity(final Subject subject, final Principal userPrincipal, final String[] roles) {<br />
        return new DefaultUserIdentity(subject,userPrincipal,roles);<br />
    }<br />
    public RunAsToken newRunAsToken(String runAsName) {<br />
        return new RoleRunAsToken(runAsName);<br />
    }</p>
<h2>LoginService实现</h2>
<p>在Jetty中，LoginService用来验证给定的用户名和证书信息(如密码)，即对应的login方法；以及验证给定的UserIdentity，即对应的validate方法；其Name属性用于标识实例本身(即作为当前使用的realm name)；另外IdentityService用于根据加载的用户名和证书信息创建UserIdentity实例。</p>
<p>public interface LoginService {<br />
    String getName();<br />
    UserIdentity login(String username,Object credentials);<br />
    boolean validate(UserIdentity user);<br />
    IdentityService getIdentityService();<br />
    void setIdentityService(IdentityService service);<br />
    void logout(UserIdentity user);<br />
}</p>
<p>为了验证用户提供的用户名和证书的正确性和合法性，需要有一个地方用来存储定义好的正确的用户名以及对应的证书信息(如密码等)，Jetty提供了DB、Properties文件、JAAS、SPNEGO作为用户信息源的比较。对于DB或Properties文件方式存储用户信息，如果每次的验证都去查询数据库或读取文件内容，效率会很低，因而还有一种实现方式是将数据库或文件中定义的用户信息预先的加载到内存中，这样每次验证只需要读取内存即可，这种方式的实现性能会提高很多，但是这样就无法动态的修改用户信息，并且如果用户信息很多，会占用很多的内存，目前Jetty采用后者实现，其中数据库存储用户信息有两个：JDBCLoginService以及DataSourceLoginService，Properties文件存储对应的实现是HashLoginService，它们都继承自MappedLoginService。在MappedLoginService中保存了一个ConcurrentMap&lt;String, UserIdentity&gt;实例，它是一个UserName到UserIdentity的映射，在该实例start时，它会从底层的数据源中加载用户信息，对HashLoginService，它会从config指定的Properties文件中加载用户信息，并填充ConcurrentMap&lt;String, UserIdentity&gt;，其中Properties文件的格式为：&lt;username&gt;=credential, role1, role2, ....如果credential以"MD5:"开头，表示它是MD5数据，如果以"CRYPT:"开头，表示它是crypt数据，否则表示它是密码字符；如果以存在的用户不在新读取的用户列表中，则将其移除，因为HashLoginService还可以启动一个线程以隔一定的时间重新加载文件中的内容，以处理文件更新的问题。在MappedLoginService中还定义了几个Principal的实现类：KnownUser、RolePrincipal、Anonymous等，在添加加载的用户时，使用KnownUser保存username和credential信息，并将该Principal添加到Subject的Principals集合中，同时对每个role创建RolePrincipal，并添加到Subject的Principals集合中，而将credential添加到Subject的PrivateCredentials集合中，使用IdentityService创建UserIdentity，并添加到ConcurrentMap&lt;String, UserIdentity&gt;中。在login验证中，首先使用传入的username查找存在的UserIdentity，并使用找到的UserIdentity中的Principal的check方法验证传入的credential，如果验证失败，返回null(即调用Credential的check方法：Password/MD5/Crypt)。对DataSourceLoginService和JDBCLoginService只是从数据库中加载用户信息，不详述。而JAASLoginService和SpnegoLoginService也只是使用各自的协议进行验证，不细述。<br />
<h2>Authenticator实现</h2>
<p>Authenticator用于验证传入的ServletRequest、ServletResponse是否包含正确的认证信息。其接口定义如下：</p>
<p>public interface Authenticator {<br />
    // Jetty支持BASIC、FORM、DIGEST、CLIENT_CERT、SPNEGO的认证，该方法返回其中的一种，或用于自定义的方法。<br />
    String getAuthMethod();</p>
<p>    // 设置配置信息(SecurityHandler继承自AuthConfiguration接口)：AuthMethod、RealmName、InitParameters、LoginService、IdentityService、IsSessionRenewedOnAuthentication<br />
    void setConfiguration(AuthConfiguration configuration);<br />
    <br />
    // 验证逻辑的实现方法，其中mandatory若为false表示当前资源有没有配置role信息，或者@ServletSecurity中的@HttpConstraint的EmptyRoleSemantic被配置为PERMIT，此时返回Deferred类型的Authentication，如果不手动的调用其authenticate或login方法，就不会对该请求进行验证。<br />
    // 对BasicAuthenticator的实现，它从Authorization请求头中获取认证信息(用户名和用户密码，使用":"分割，并且使用Base64编码)，调用LoginService进行认证，当认证通过时，如果配置了renewSession为true，则将HttpSession中的所有属性更新一遍，并且添加(org.eclipse.jetty.security.secured, True) entry，并使用UserIdentity以及AuthMethod创建UserAuthentication返回。如果认证失败，则返回401 Unauthorized错误，并且在相应消息中包含头：WWW-Authenticate: basic realm=&lt;LoginService.name&gt;<br />
    // 对FormAuthenticator的实现，它首先要配置formLoginPage、formLoginPath(默认j_security_check)、formErrorPage、formErrorPath；只有当前请求URL是formLoginPath时，从j_username和j_password请求参数中获取username和password信息，使用LoginService验证，如果验证通过且这个请求是因为之前请求其他资源重定向过来的，这重定向到之前的URL，创建一个SessionAuthentication放入HttpSession中，并返回一个新创建的FormAuthentication；如果验证失败，如果没定义formErrorPage，返回403 Forbidden相应，否则重定向或forward到formErrorPage；对于其他URL请求，查看在当前Session中是否存在已认证的Authentication，如果有，但是重新验证缓存的Authentication失败，则将这个Authentication从HttpSession中移除；否则返回这个Session中的Authentication；对于其他情况，表示当前请求需要认证后才能访问，此时保存当前请求URI以及POST数据到Session中，以在认证之后可以直接跳转，然后重定向或forward到formLoginPage中。<br />
    // 对DigestAuthenticator的实现类似BasicAuthenticator，只是它使用Digest的方式对认证数据进行加密和解密。<br />
    // 对ClientCertAuthenticator则采用客户端证书的方式认证，SpnegoAuthenticator使用SPNEGO方式认证，JaspiAuthenticator使用JASPI方式认证。 <br />
    Authentication validateRequest(ServletRequest request, ServletResponse response, boolean mandatory) throws ServerAuthException;<br />
    <br />
    // 只用于JaspiAuthenticator，用于所有后继handler处理完成后对ServletRequest、ServletResponse、User的进一步处理，目前不了解JASPI的协议逻辑，因而不了解具体的用途。<br />
    boolean secureResponse(ServletRequest request, ServletResponse response, boolean mandatory, User validatedUser) throws ServerAuthException;<br />
}</p>
<h2>SecurityHandler与ConstraintSecurityHandler实现</h2>
<p>SecurityHandler继承自HandlerWrapper，并实现了Authenticator.AuthConfiguration接口，因而它包含了realm、authMethod、initParameters、loginService、identityService、renewSession等字段，在其start时，它会首先从ServletContext的InitParameters中导入org.eclipse.jetty.security.*属性的值到其InitParameters中，如果LoginService为null，则从Server中查找一个已经注册的LoginService，使用Authenticator.Factory根据AuthMethod创建对应的Authenticator实例。</p>
<p>ConstraintSecurityHandler继承自SecurityHandler类，它定义了ConstraintMapping列表、所有定义的role、以及pathSpec到Map&lt;String, RoleInfo&gt;(key为httpMethod，RoleInfo包含UserDataConstraint枚举类型和roles集合)的映射，其中ConstraintMapping中保存了method、methodOmissions、pathSpec、Constraint(Constraint中包含了name、roles、dataConstraint等信息)，ConstraintMapping在解析web.xml文件时添加，它对应&lt;security-constraint&gt;下的配置，如auth-constraint下的role-name配置对应roles数组，user-data-contraint对应dataConstraint，web-resource-name对应name，http-method对应method，url-pattern对应pathSpec；在每次添加ConstraintMapping时都会更新roles列表以及pathSpec到Map&lt;String, RoleInfo&gt;的映射。</p>
<p>在SecurityHandler的handle方法中，它只需要对REQUEST、ASYNC类型的DispatcherType需要验证：它首先根据pathInContext和Request实例查找RoleInfo信息；如果RoleInfo处于forbidden状态，发送403 Forbidden相应，如果DataConstraint配置了Intergal、Confidential，但是Connector中没有配置相应的port，则发送403 Forbidden相应，否则重定向请求到Integral、Confidential对应的URL；对没有验证过的请求调用Authenticator.validateRequest()对请求进行验证；如果验证的结果是Authentication.ResponseSent，设置Request的handled为true，如果为Authentication.User，表示认证成功，设置该Authentication到Request中，并检查role，即检查当前User是否处于RoleInfo中的role集合中，如果不是，发送403 Forbidden响应，否则调用下一个handler的handle方法，之后调用Authenticator.secureResponse()方法；如果验证结果是Authentication.Deferred，在调用下一个handler的handle方法后调用Authenticator.secureResponse()方法；否则直接调用Authenticator.secureResponse()方法。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:31:00</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>深入Jetty源码之SecurityHandler的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxY72Pp.html" rel="bookmark">深入Jetty源码之ContextHandler</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 ContextHandler继承自ScopedHandler,它是Jetty中实现对一个Web Application的各种资源进行管理,并串联实现整个Servlet框架的类,比如它部分实现了ServletContext接口,并且在其doScope方法中为当前Request的执行提供了相应的环境,如设置servletPath.pathInfo.设置ServletContext到ThreadLocal中.在Jetty中,Servlet的执行流程和框架由ServletHandler实现,Sec			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1l5Bdb.html" rel="bookmark">深入Jetty源码之Handler总述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Handler概述 Handler是Jetty中的核心接口,它用于处理所有连接以外的逻辑,比如对Servlet框架的实现,以及用户自定义的Handler等,它继承自LifeCycle和Destroyable接口,只有一个主要方法:handle,包含Request和Response实例.在深入Jetty源码之Connection中有写道在HttpConnection的handleRequest()方法中会最终调用Server的handle()或handleAsync()方法,并且传入HttpCon			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvn9q1M.html" rel="bookmark">深入Jetty源码之Connector</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Connector概述 Connector是Jetty中可以直接接受客户端连接的抽象,一个Connector监听Jetty服务器的一个端口,所有客户端的连接请求首先通过该端口,而后由操作系统分配一个新的端口(Socket)与客户端进行数据通信(先握手,然后建立连接,但是使用不同的端口).不同的Connector实现可以使用不同的底层结构,如Socket Connector.NIO Connector等,也可以使用不同的协议,如Ssl Connector.AJP Connector,从而在不同的C			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/badPRPz.html" rel="bookmark">深入Jetty源码之Servlet框架及实现&lpar;ServletRequest、ServletResponse&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 Servlet是Server Applet的缩写,即在服务器端运行的小程序,而Servlet框架则是对HTTP服务器(Servlet Container)和用户小程序中间层的标准化和抽象.这一层抽象隔离了HTTP服务器的实现细节,而Servlet规范定义了各个类的行为,从而保证了这些&quot;服务器端运行的小程序&quot;对服务器实现的无关性(即提升了其可移植性).在Servlet规范有以下几个核心类(接口):ServletContext:定义了一些可以和Servlet Container交互的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mxoa1yb.html" rel="bookmark">深入Jetty源码之Connection</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 当Jetty中的Connector收到一个客户端的连接时(ServerSocket或ServerSocketChannel的accept()方法返回),Connector会首先创建一个ConnectedEndPoint用于和连接的底层(Socket.Channel)打交道(读写数据),在创建的ConnectedEndPoint时会同时使用该EndPoint创建相应类型的Connection,然后会创建一个Task仍给线程池,最终线程池会启动一个线程启动这个Task,而在这个Task中调用C			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bod8DvM.html" rel="bookmark">深入Jetty源码之HttpGenerator</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于抽象和聚合原则,Jetty中需要一个单独的类来专门处理HTTP响应消息和请求消息的生成和发送,Jetty的作者将该抽象(接口)命名为Generator,它有两个实现类:HttpGenerator和NestedGenerator.其类图如下: Generator接口 HTTP请求消息分为请求行.消息报头.请求正文三部分,HTTP响应消息分为状态行.消息报头.消息正文.在HTTP请求消息和响应消息格式的唯一区别是请求行和状态行,因而只需要将这一行的内容区分开来,其他的可以共享逻辑. 请求行和响应			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqgD9ez.html" rel="bookmark">深入Jetty源码之DescriptorProcessor实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 在Jetty中,所有XML文件的配置使用Descriptor来表达,而对这些Descriptor的处理使用DescriptorProcessor来实现. Descriptor和DescriptorProcessor类图 Descriptor实现 Descriptor可以表达一个*.tld文件(TldDescriptor).一个/META-INF/web.xml文件(WebDescriptor),一个/org/eclipse/jetty/webapp/webdefault.xml(Defau			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRq33z.html" rel="bookmark">深入Jetty源码之Servlet框架及实现&lpar;AsyncContext、RequestDispatcher、HttpSession&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 Servlet是Server Applet的缩写,即在服务器端运行的小程序,而Servlet框架则是对HTTP服务器(Servlet Container)和用户小程序中间层的标准化和抽象.这一层抽象隔离了HTTP服务器的实现细节,而Servlet规范定义了各个类的行为,从而保证了这些&quot;服务器端运行的小程序&quot;对服务器实现的无关性(即提升了其可移植性).在Servlet规范有以下几个核心类(接口):ServletContext:定义了一些可以和Servlet Container交互的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPP161p.html" rel="bookmark">深入Jetty源码之Servlet框架及实现&lpar;ServletContext&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 Servlet是Server Applet的缩写,即在服务器端运行的小程序,而Servlet框架则是对HTTP服务器(Servlet Container)和用户小程序中间层的标准化和抽象.这一层抽象隔离了HTTP服务器的实现细节,而Servlet规范定义了各个类的行为,从而保证了这些&quot;服务器端运行的小程序&quot;对服务器实现的无关性(即提升了其可移植性). 在Servlet规范有以下几个核心类(接口):ServletContext:定义了一些可以和Servlet Container交互			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqJdOp.html" rel="bookmark" class="title">如何解决网站首页打开慢的问题</a>
					<div>
						自己的网站首页为什么打开那么慢呢? 分析一下吧,原因可能是: 一: 你的网速过慢 二: 图片过多 三: 表格嵌套过多. 四: 图片太大 五: 网页表格太大 六: 网页代码不规范.垃圾代码较多					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjZYOp.html" rel="bookmark" class="title">一起学DNS系列（一）基础、概览</a>
					<div>
						本系列主要讲述有关Windows下DNS服务器的相关知识点,由于DNS和AD结合异常紧密,所以与AD相关的DNS应用和知识将在AD专栏中讲述. 此为本系列的第一节. 我想没有什么人在访问的时候会直接输 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPkoQz.html" rel="bookmark" class="title">解决Windows 7系统中软件乱码问题</a>
					<div>
						笔者是一位Windows7的测试用户,一路从最开始的6801到目前的7068,都使用过,当然也遇到了很多麻烦事,不过总体来说Windows7确实不错,它有着XP的速度和Vista的界面,表里如一,对于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAa4aKM.html" rel="bookmark" class="title">Win8&period;1系统笔记本充电15&percnt;时直接跳到100&percnt;怎么办？</a>
					<div>
						Win8.1系统笔记本充电15%时直接跳到100%怎么办?   解决方法如下: 1.尝试到您的品牌机的官网上面下载最新的电源驱动. 2.建议联系品牌机的售后,做一个硬件的检测,排除一下问题. Win8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Wmq6b.html" rel="bookmark" class="title">风行让你随时随地享用无尽优质影视</a>
					<div>
						&lt;十二生肖&gt;.&lt;樱桃红&gt;.&lt;贤妻&gt;,现在可以看的片子还真不少,通过风行这些大片都可以免费观看.但是并不是所有的时候都能像现在想这样有这么多明显的大片等着你的,到那时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGkqDb.html" rel="bookmark" class="title">如何优化出一个高质量的单页</a>
					<div>
						一个高质量的网页可以给网站很大的帮助,可以提高网站的流量.提高网站和栏目的整体权重.提高转化率还有提高网站的品牌效应.既然高质量网页有这么多的用处,那么要如何打造一个高质量的网页呢?本人觉得高质量的网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOavExM.html" rel="bookmark" class="title">阿里云MVP Meetup极客开跑，与MVP一起玩转云计算</a>
					<div>
						9月2日,在杭州科技寺创业空间,开展了一场开发圈的线下交流会,这是阿里云及MVP.合作伙伴们共同举办的首次MVP线下沙龙会,是增强与开发者感情的第一次尝试. 沙龙分为三个组成部分:MVP分享.提问.自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8k2k3M.html" rel="bookmark" class="title">jQuery-onload让第一次页面加载时图片是淡入方式显示&lowbar;jquery</a>
					<div>
						复制代码 代码如下: $(&quot;#load img&quot;).load(function() { //图片默认隐藏 $(this).hide(); //使用fadeIn特效 $(this). ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6WBAb.html" rel="bookmark" class="title">arm11-ARM11外部中断无法跳出</a>
					<div>
						问题描述 ARM11外部中断无法跳出 在OK6410上测试外部按键中断,中断进入后没有跳出,怎么回事 解决方案 调试下,可能是中断的错误 解决方案二: 1.看看是不是你在中断里面有死循环语句: 2.你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NV8yM.html" rel="bookmark" class="title">json格式问题。。。。</a>
					<div>
						问题描述 json格式问题.... { &quot;attributes&quot; : { }, &quot;obj&quot;:{ code:&quot;自定义业务code&quot; msg:& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2yqqb.html" rel="bookmark" class="title">android-一个Activity实时监听另一个Activity中参数的变化</a>
					<div>
						问题描述 一个Activity实时监听另一个Activity中参数的变化 假如我有两个Activity:Activity(A)和Activity(B) Activity(A)中有一个按钮,有两种状态  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkgD4b.html" rel="bookmark" class="title">ExtJS之布局篇 &period;</a>
					<div>
						Ext布局总的来说是很灵活的,因此我觉得有必要一块探讨一下. Ext常用的布局都在Ext.layout下,这里几乎涵盖了所有的布局方式(但是值得注意的是通常我们不是直接通过&quot;new&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGADPOM.html" rel="bookmark" class="title">Android开发入门之对话框简单用法&lowbar;Android</a>
					<div>
						本文实例讲述了Android开发入门之对话框简单用法.分享给大家供大家参考,具体如下: 注:本文只是一个学习笔记 用以记录自己学到哪了 1.获得AlertDialog的静态内部类Builder对象,由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKaYEb.html" rel="bookmark" class="title">【Go语言】【11】GO语言的包和函数</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://qingkechina.blog.51cto.com/5552198/166523 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD5dkz.html" rel="bookmark" class="title">hashcode-关系多态的问题，为何重写了equals 却没有调用</a>
					<div>
						问题描述 关系多态的问题,为何重写了equals 却没有调用 import java.util.*; class Name{ private String firstname,secondname;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydkY5b.html" rel="bookmark" class="title">生成随机数rand函数的用法详解&lowbar;C 语言</a>
					<div>
						函数rand()是真正的随机数生成器,而srand()会设置供rand()使用的随机数种子.如果你在第一次调用rand()之前没有调用srand(),那么系统会为你自动调用srand().而使用同种子 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RORQb.html" rel="bookmark" class="title">畅捷通入驻阿里云市场，为小微企业在线&OpenCurlyDoubleQuote;号脉开方&rdquo;</a>
					<div>
						5月23日,云栖大会成都峰会上,用友畅捷通将与阿里云和众多合作伙伴一起发布&quot;生态密码&quot;,揭开阿里云生态的新布局.而早在本次发布前,畅捷通就已入驻阿里云市场,借最强的线上交易与交付平 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnED1M.html" rel="bookmark" class="title">java socket 开发，请高手指点，谢谢。</a>
					<div>
						问题描述 java socket 开发,请高手指点,谢谢. 1.需要实现跟服务器进行客户数据的同步! 2.报文编码:GBK 3.请求报文格式: [192.168.1.189][01][张三][1865 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJV3Qp.html" rel="bookmark" class="title">c&num;中什么控件既能显示文字又能显示图片？</a>
					<div>
						问题描述 我做的qq如何把表情添加到控件中? 解决方案 解决方案二:textbox吧,文字显示在框内,图片就用做背景.解决方案三:winform,richtextboxwebform,htmledit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Rj9nz.html" rel="bookmark" class="title">求VC&plus;&plus;实效编程百例</a>
					<div>
						问题描述 我有源码了,谁可以给我它的电子版-..谢谢shinwei.lee@gmail.com 解决方案 解决方案二:http://www.vsfan.net/site/Software.asp?id ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqaXJp.html" rel="bookmark" class="title">组图：陈奕迅视奖杯如废品被乞丐颁奖不尴尬</a>
					<div>
						陈奕迅开心拿奖 陈奕迅视奖杯如废品 陈奕迅接受犀利颁奖 陈奕迅拥抱&quot;犀利哥&quot; 陈奕迅满脸堆笑 陈奕迅致辞 陈奕迅披风上阵 陈奕迅项链造型(点击小图看大图)点击此处查看其它图片 新浪 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNZ29p.html" rel="bookmark" class="title">Nginx提示502 Bad Gateway错误问题解决方法小结</a>
					<div>
						502 Bad Gateway错误问题解决方法 Nginx 502错误的原因比较多,是因为在代理模式下后端服务器出现问题引起的.这些错误一般都不是nginx本身的问题,一定要从后端找原因!但nginx ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmZ0Yp.html" rel="bookmark" class="title">jquery 使用鼠标滚轮或者手势滑动到页面节点部分例子</a>
					<div>
						有时我们需要做一个单页面介绍产品特性,而单页面内容非常多且页面非常长,为了快速定位到产品特性节点,我们使用js侦听用户滚轮事件,当用户触发滚轮滑动或者使用手势触屏滑动时,即可定位到相应的节点.一款jQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvadmM.html" rel="bookmark" class="title">Access数据库升级为SQL数据库的注意事项和方法&lowbar;数据库其它</a>
					<div>
						很多Access和SQL Server开发人员都经常面临着将一个Access数据库升级到SQL Server数据库的问题.由于存在现有的Access升级向导,这一转变的过程就会变得相当简单,尤其是当你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlG9qp.html" rel="bookmark" class="title">《淘宝网开店 拍摄 修图 设计 装修 实战150招》一一2&period;3　商品摆放的重要性</a>
					<div>
						2.3 商品摆放的重要性 在拍摄商品照片之前,必须先将要拍摄的商品进行合理的组合,设计出一个最佳的摆放角度,为拍摄时的构图和取景做好前期的准备工作.商品采用什么摆放角度和组合最能体现产品的性能.特点及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqW9ap.html" rel="bookmark" class="title">网站建设之&OpenCurlyDoubleQuote;枪打出头鸟&rdquo;心态要不得</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 今天周末,上午比较闲,依然照常抽出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YWjap.html" rel="bookmark" class="title">实战对等无线网络</a>
					<div>
						看了&lt;http://www.aliyun.com/zixun/aggregation/32544.html&quot;&gt;无线网卡安装DIY&gt;一文,文章中涉及了多种接口的无线网卡(PC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wgBKz.html" rel="bookmark" class="title">中国IT产业人才分布地图&lpar;图&rpar;</a>
					<div>
						IT产业布局在不断扩散.转移,其赖以生存的IT人才在哪里,可以查看IT人力资本分布地图. 赵鑫|文 2010中国IT市场年会上,工业和信息化部总经济师周子学曾指出中国的IT产业存在两大问题,其一便是惯 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRyPDz.html" rel="bookmark" class="title">遨游</a>
					<div>
						问题描述 遨游浏览器怎么实现的,是多线程是吗,还有就是数据库优化怎么实现的.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNmWrmb.html" rel="bookmark" class="title">flexjson-Flex开发使用Json格式和数据库交互页面加载数据奇慢</a>
					<div>
						问题描述 Flex开发使用Json格式和数据库交互页面加载数据奇慢 数据库使用的是Mysql.服务器是Apache服务器.使用Flex Builder 4.6 IDE .MXML所做的操作就是增删改查 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
